'use strict'

const path = require('path')

const PATH_NAME = 'dist'

module.exports = {
  outputDir: PATH_NAME,
  publicPath: process.env.NODE_ENV === 'production' ? `/${PATH_NAME}/` : '/',
  configureWebpack: {
    resolve: {
      alias: {
        '@': path.resolve('src'),
        '@api': path.resolve('src/api')
      }
    },
    devServer: {
      headers: {
        // 'Access-Control-Allow-Origin': '*'
      },
      disableHostCheck: true
    }
  },
  css: {
    sourceMap: process.env.NODE_ENV === 'development',
    requireModuleExtension: true,
    loaderOptions: {
      less: {
        lessOptions: {
        }
      }
    }
  }
}
